@echo off

:setup
:main

Call :ListFunctionsRows "%~1"

GoTo :EOF

::Usage Call :ListFunctions BatchFile 
::Prints out a list of all non-excluded functions
:ListFunctionsRows
set "_ListFunctionsRows_prefix=_LFR"
set "_LFR_BatchFile=%~1"

Call :GetFunctionsFromBatch "%_LFR_BatchFile%" _LFR
set /a "_LFR_index=0"
set /a _LFR_function.ubound=-1
REM set _LFR
:ListFunctionsRows-loop

REM echo _LFR_index %_LFR_index%
call set "_LFR_name=%%_LFR.labels[%_LFR_index%].name%%"
REM if defined _LFR_name echo %_LFR_name%

if defined _LFR_name set /a _LFR_function.ubound+=1
if defined _LFR_name Call :GetFunctionRows _LFR %_LFR_name% _LFR_function[%_LFR_function.ubound%]
if defined _LFR_name Call :PrintFunctionRows _LFR _LFR_function[%_LFR_function.ubound%]

set /a "_LFR_index+=1"
if %_LFR_index% LEQ %_LFR.labels.ubound% GoTo :ListFunctionsRows-loop
REM Call :CompactArray _LFR.labels
REM Call :EchoArray _LFR.labels VERTICALMODE .name
REM Call :ClearVariablesByPrefix %_ListFunctionsRows_prefix% _ListFunctionsRows_prefix
GoTo :EOF


::Usage Call :PrintFunctionRows FunctionArray RowsObject
:PrintFunctionRows
set "_PrintFunctionRows_prefix=_PFR"
set "_PFR_Input=%~1"
shift 
:PrintFunctionRows-args
set "_PFR_object=%~1"
call set "_PFR_name=%%%_PFR_object%.name%%"
call set "_PFR_preamble=%%%_PFR_object%.preamble%%"
call set "_PFR_body=%%%_PFR_object%.body%%"
call set "_PFR_end=%%%_PFR_object%.end%%"
call set "_PFR_postscript=%%%_PFR_object%.postscript%%"
Call :PadString 20 %_PFR_name% _PFR_name
echo Function %_PFR_name% : preamble [%_PFR_preamble%] body [%_PFR_body%] end [%_PFR_end%] postscript [%_PFR_postscript%]
if "[%~2]" NEQ "[]" ( shift & GoTo :PrintFunctionRows-args )
Call :ClearVariablesByPrefix %_PrintFunctionRows_prefix% _PrintFunctionRows_prefix 
GoTo :EOF

::Usage Call :GetFunctionsFromBatch BatchFile Output
:GetFunctionsFromBatch
set "_GetFunctionsFromBatch_prefix=_GFFB"
set "_GFFB_BatchFile=%~1"
set "_GFFB_FunctionArray=%~2"
REM goto :GetFunctionsFromBatch-skip
Call :GetLabels "%_GFFB_BatchFile%" %_GFFB_FunctionArray%.labels
Call :RemoveNonFunctionLabels %_GFFB_FunctionArray%.labels
Call :GetFunctionExits "%_GFFB_BatchFile%" %_GFFB_FunctionArray%.exits
Call :GetEmptyLines "%_GFFB_BatchFile%" %_GFFB_FunctionArray%.empty
Call :GetEndOfFunction "%_GFFB_BatchFile%" %_GFFB_FunctionArray%.endof
:GetFunctionsFromBatch-skip
Call :GetFunctionDescriptor %_GFFB_FunctionArray% %_GFFB_FunctionArray%.labels %_GFFB_FunctionArray%.exits %_GFFB_FunctionArray%.empty %_GFFB_FunctionArray%.endof
REM Call :ClearVariablesByPrefix %_GetFunctionsFromBatch_prefix% _GetFunctionsFromBatch
set "_GetFunctionsFromBatch_prefix=" & set "_GFFB_BatchFile=" & set "_GFFB_Output=" & set "_GFFB_FunctionArray="
GoTo :EOF

::Usage Call :GetFunctionRows FunctionArray NameOfFunction RowsObject
:GetFunctionRows
set "_GetFunctionRows_prefix=_GFR"
set "_GFR_Input=%~1"
shift
:GetFunctionRows-args
set "_GFR_FunctionName=%~1"
set "_GFR_ReturnValue=%~2"
set "_GFR_body=" & set "_GFR_preamble=" & set "_GFR_end=" & set "_GFR_postscript="
Call :FindFunctionLabel %_GFR_Input% %_GFR_FunctionName% _GFR_body_index 
call set /a "_GFR_body=%%%_GFR_Input%[%_GFR_body_index%]%%"
Call :FindPreviousEmptyRow %_GFR_Input% %_GFR_body_index% _GFR_preamble
Call :FindFunctionExit %_GFR_Input% %_GFR_body_index% _GFR_end_index
call set /a "_GFR_end=%%%_GFR_Input%[%_GFR_end_index%]%%"
Call :FindNextEmptyRow %_GFR_Input% %_GFR_end_index% _GFR_postscript
Call :GetEndOfFunctionRow %_GFR_Input% %_GFR_FunctionName% _GFR_endof || set /a "_GFR_end=%_GFR_endof%"
set "%_GFR_ReturnValue%.name=%_GFR_FunctionName%"
set "%_GFR_ReturnValue%.body=%_GFR_body%"
set "%_GFR_ReturnValue%.preamble=%_GFR_preamble%"
set "%_GFR_ReturnValue%.end=%_GFR_end%"
set "%_GFR_ReturnValue%.postscript=%_GFR_postscript%"
if "[%~3]" NEQ "[]" if "[%~4]" NEQ "[]" ( shift & shift & GoTo :GetFunctionRows-args )
GoTo :EOF

::Usage Call :GetFunctionDescriptor OutputArray LabelsArray ExitsArray EmptyArray EOFArray 
:GetFunctionDescriptor
set "_GetFunctionDescriptor_prefix=_GFDA"
set "_GFDA_Output=%~1"
set "_GFDA_Labels=%~2"
set "_GFDA_Exits=%~3"
set "_GFDA_Empty=%~4"
set "_GFDA_EOF=%~5"
call set /a "_GFDA_Output_lbound=%%%_GFDA_Output%.lbound%%" 2>nul
call set /a "_GFDA_Labels_lbound=%%%_GFDA_Labels%.lbound%%"
call set /a "_GFDA_Exits_lbound=%%%_GFDA_Exits%.lbound%%"
call set /a "_GFDA_Empty_lbound=%%%_GFDA_Empty%.lbound%%"
call set /a "_GFDA_EOF_lbound=%%%_GFDA_EOF%.lbound%%"
if "[%_GFDA_Output_lbound%]" EQU "[]" set /a "_GFDA_Output_lbound=0"
if "[%_GFDA_Labels_lbound%]" EQU "[]" set /a "_GFDA_Labels_lbound=0"
if "[%_GFDA_Exits_lbound%]" EQU "[]" set /a "_GFDA_Exits_lbound=0"
if "[%_GFDA_Empty_lbound%]" EQU "[]" set /a "_GFDA_Empty_lbound=0"
if "[%_GFDA_EOF_lbound%]" EQU "[]" set /a "_GFDA_EOF_lbound=0"
call set /a "_GFDA_Output_ubound=%%%_GFDA_Output%.ubound%%" 2>nul
call set /a "_GFDA_Labels_ubound=%%%_GFDA_Labels%.ubound%%" 2>nul
call set /a "_GFDA_Exits_ubound=%%%_GFDA_Exits%.ubound%%" 2>nul
call set /a "_GFDA_Empty_ubound=%%%_GFDA_Empty%.ubound%%" 2>nul
call set /a "_GFDA_EOF_ubound=%%%_GFDA_EOF%.ubound%%" 2>nul
if "[%_GFDA_Output_ubound%]" EQU "[]" set /a _GFDA_Output_ubound=%_GFDA_Output_lbound%-1
if "[%_GFDA_Labels_ubound%]" EQU "[]" set /a _GFDA_Labels_ubound=%_GFDA_Output_lbound%-1
if "[%_GFDA_Exits_ubound%]" EQU "[]" set /a _GFDA_Exits_ubound=%_GFDA_Output_lbound%-1
if "[%_GFDA_Empty_ubound%]" EQU "[]" set /a _GFDA_Empty_ubound=%_GFDA_Output_lbound%-1
if "[%_GFDA_EOF_ubound%]" EQU "[]" set /a _GFDA_EOF_ubound=%_GFDA_Output_lbound%-1
call set /a "_GFDA_Output_index=%_GFDA_Output_ubound%" 2>nul
call set /a "_GFDA_Labels_index=%_GFDA_Labels_lbound%"
call set /a "_GFDA_Exits_index=%_GFDA_Exits_lbound%"
call set /a "_GFDA_Empty_index=%_GFDA_Empty_lbound%"
call set /a "_GFDA_EOF_index=%_GFDA_EOF_lbound%"
call set "_GFDA_Labels_last_line=%%%_GFDA_Labels%[%_GFDA_Labels_ubound%]%%"
call set "_GFDA_Exits_last_line=%%%_GFDA_Exits%[%_GFDA_Exits_ubound%]%%"
call set "_GFDA_Empty_last_line=%%%_GFDA_Empty%[%_GFDA_Empty_ubound%]%%"
call set "_GFDA_EOF_last_line=%%%_GFDA_EOF%[%_GFDA_EOF_ubound%]%%"
if not defined _GFDA_Labels_last_line set /a _GFDA_Labels_last_line=0
if not defined _GFDA_Exits_last_line set /a _GFDA_Exits_last_line=0
if not defined _GFDA_Empty_last_line set /a _GFDA_Empty_last_line=0
if not defined _GFDA_EOF_last_line set /a _GFDA_EOF_last_line=0
set "_GFDA_line_lastline=0"
if %_GFDA_Labels_last_line% GTR %_GFDA_line_lastline% set /a _GFDA_line_lastline=%_GFDA_Labels_last_line%
if %_GFDA_Exits_last_line% GTR %_GFDA_line_lastline% set /a _GFDA_line_lastline=%_GFDA_Exits_last_line%
if %_GFDA_Empty_last_line% GTR %_GFDA_line_lastline% set /a _GFDA_line_lastline=%_GFDA_Empty_last_line%
if %_GFDA_EOF_last_line% GTR %_GFDA_line_lastline% set /a _GFDA_line_lastline=%_GFDA_EOF_last_line%
:GetFunctionDescriptor-loop
set "_GFDA_line_lowestline=%_GFDA_line_lastline%" & set "_GFDA_line_next_element=" & set "_GFDA_line_next_element_type="
call set "_GFDA_Labels_current_line=%%%_GFDA_Labels%[%_GFDA_Labels_index%]%%"
call set "_GFDA_Exits_current_line=%%%_GFDA_Exits%[%_GFDA_Exits_index%]%%"
call set "_GFDA_Empty_current_line=%%%_GFDA_Empty%[%_GFDA_Empty_index%]%%"
call set "_GFDA_EOF_current_line=%%%_GFDA_EOF%[%_GFDA_EOF_index%]%%"
if "[%_GFDA_Labels_current_line%]" EQU "[]" ( set /a "_GFDA_Labels_current_line=%_GFDA_line_lastline%+1" & if %_GFDA_Labels_index% LEQ %_GFDA_Labels_ubound% set /a _GFDA_Labels_index+=1 )
if "[%_GFDA_Exits_current_line%]" EQU "[]" ( set /a "_GFDA_Exits_current_line=%_GFDA_line_lastline%+1" & if %_GFDA_Exits_index% LEQ %_GFDA_Exits_ubound% set /a _GFDA_Exits_index+=1 )
if "[%_GFDA_Empty_current_line%]" EQU "[]" ( set /a "_GFDA_Empty_current_line=%_GFDA_line_lastline%+1" & if %_GFDA_Empty_index% LEQ %_GFDA_Empty_ubound% set /a _GFDA_Empty_index+=1 )
if "[%_GFDA_EOF_current_line%]" EQU "[]" ( set /a "_GFDA_EOF_current_line=%_GFDA_line_lastline%+1" & if %_GFDA_EOF_index% LEQ %_GFDA_EOF_ubound% set /a _GFDA_EOF_index+=1 )
if %_GFDA_Labels_index% LEQ %_GFDA_Labels_ubound% if %_GFDA_Labels_current_line% LSS %_GFDA_line_lowestline% set "_GFDA_line_next_element=_GFDA_Labels" & set /a "_GFDA_line_lowestline=%_GFDA_Labels_current_line%" 2>nul
if %_GFDA_Exits_index% LEQ %_GFDA_Exits_ubound% if %_GFDA_Exits_current_line% LSS %_GFDA_line_lowestline% set "_GFDA_line_next_element=_GFDA_Exits" & set /a "_GFDA_line_lowestline=%_GFDA_Exits_current_line%" 2>nul
if %_GFDA_Empty_index% LEQ %_GFDA_Empty_ubound% if %_GFDA_Empty_current_line% LSS %_GFDA_line_lowestline% set "_GFDA_line_next_element=_GFDA_Empty" & set /a "_GFDA_line_lowestline=%_GFDA_Empty_current_line%" 2>nul
if %_GFDA_EOF_index% LEQ %_GFDA_EOF_ubound% if %_GFDA_EOF_current_line% LSS %_GFDA_line_lowestline% set "_GFDA_line_next_element=_GFDA_EOF" & set /a "_GFDA_line_lowestline=%_GFDA_EOF_current_line%" 2>nul
set "_GFDA_line_next_element_type=%_GFDA_line_next_element:~6%"
REM echo _GFDA_Labels_current_line %_GFDA_Labels_current_line% _GFDA_Exits_current_line %_GFDA_Exits_current_line% _GFDA_Empty_current_line %_GFDA_Empty_current_line% _GFDA_EOF_current_line %_GFDA_EOF_current_line% %_GFDA_Output%[%_GFDA_Output_index%]
if "[%_GFDA_line_next_element%]" NEQ "[]"  (
	set /a _GFDA_Output_index+=1
	set /a _GFDA_Output_ubound+=1
	call call set /a %_GFDA_Output%[%%_GFDA_Output_index%%]=%%%%%%%_GFDA_line_next_element%%%[%%%_GFDA_line_next_element%_index%%]%%%%
	call set %_GFDA_Output%[%%_GFDA_Output_index%%].type=%_GFDA_line_next_element:~6%
	if "[%_GFDA_line_next_element_type%]" EQU "[Labels]" call set "%_GFDA_Output%[%%_GFDA_Output_index%%].name=%%%_GFDA_Labels%[%_GFDA_Labels_index%].name%%"
	if "[%_GFDA_line_next_element_type%]" EQU "[EOF]" call set "%_GFDA_Output%[%%_GFDA_Output_index%%].name=%%%_GFDA_EOF%[%_GFDA_EOF_index%].name%%"
	set /a %_GFDA_line_next_element%_index+=1
	GoTo :GetFunctionDescriptor-loop
	)
set /a "%_GFDA_Output%.lbound=%_GFDA_Output_lbound%"
set /a "%_GFDA_Output%.ubound=%_GFDA_Output_ubound%"
REM echo function finished %_GFDA_line_next_element%
Call :ClearVariablesByPrefix %_GetFunctionDescriptor_prefix% _GetFunctionDescriptor
GoTo :EOF


::Usage Call :GetLabels BatchFile LabelObjectArray optional RowsArray
:GetLabels
set "_GetLabels_output=%~2"
if "[%~3]" EQU "[]" ( set "_GetLabels_output_rows=%_GetLabels_output%.rows" ) else ( set "_GetLabels_output_rows=%~3" )
for /f delims^=^ eol^= %%a in ('%SystemRoot%\System32\findstr /N "^:[^:]" "%~1" ^| findstr /N "^"') do (
	for /f "tokens=1,2,3* delims=:" %%f in ("%%a") do set /a "%_GetLabels_output%.ubound=%%f" & set %_GetLabels_output%[%%f]=%%g
	for /f "tokens=1,2,3* delims=:" %%f in ("%%a") do set %_GetLabels_output_rows%[%%g].type=label
	for /f "tokens=1,2,3* delims=:" %%f in ("%%a") do for /f "tokens=1,2*" %%z in ("%%h") do set %_GetLabels_output%[%%f].name=%%~z
	for /f "tokens=1,2,3* delims=:" %%f in ("%%a") do for /f "tokens=1,2*" %%z in ("%%h") do set %_GetLabels_output%.name[%%~z]=%%g
	for /f "tokens=1,2,3* delims=:" %%f in ("%%a") do for /f "tokens=1,2*" %%z in ("%%h") do set %_GetLabels_output_rows%[%%g]=%%~z
	)
set /a "%_GetLabels_output%.lbound=1" & set "_GetLabels_output=" & set "_GetLabels_output_rows="
GoTo :EOF

::Usage Call :GetFunctionExits Filename OutputArray
:GetFunctionExits
set "_GetFunctionExits_output=%~2"
if "[%~3]" EQU "[]" ( set "_GetFunctionExits_output_rows=%_GetFunctionExits_output%.rows" ) else ( set "_GetFunctionExits_output_rows=%~3" )
for /f delims^=^ eol^= %%a in ('%SystemRoot%\System32\findstr /N /I /C:"goto :EOF" /C:"exit /B" "%~1" ^| findstr /N "^"') do ( 
	for /f "tokens=1,2,3* delims=:" %%f in ("%%a") do set /a "%_GetFunctionExits_output%.ubound=%%f" & set %_GetFunctionExits_output%[%%f]=%%g
	for /f "tokens=1,2,3* delims=:" %%f in ("%%a") do set %_GetFunctionExits_output_rows%[%%g].type=FunctionExit
	for /f "tokens=1,2,3* delims=:" %%f in ("%%a") do for /f "tokens=2,* delims=:" %%b in ("%%a") do set %_GetFunctionExits_output%[%%f].text=%%c
	for /f "tokens=1,2,3* delims=:" %%f in ("%%a") do for /f "tokens=2,* delims=:" %%b in ("%%a") do set %_GetFunctionExits_output_rows%[%%g].text=%%c
	)
set /a "%_GetFunctionExits_output%.lbound=1" & set "_GetFunctionExits_output=" & set "_GetFunctionExits_output_rows="
GoTo :EOF
::Usage Call :GetEmptyLines Filename OutputArray optional OutputRows
:GetEmptyLines
set "_GetEmptyLines_output=%~2"
if "[%~3]" EQU "[]" ( set "_GetEmptyLines_output_rows=%_GetEmptyLines_output%.rows" ) else ( set "_GetEmptyLines_output_rows=%_GetEmptyLines_output%" )
for /f delims^=^ eol^= %%a in ('%SystemRoot%\System32\findstr /N "^$" "%~1" ^| findstr /N "^"') do ( 
	for /f "tokens=1,2* delims=:" %%f in ("%%a") do set /a "%_GetEmptyLines_output%.ubound=%%f" & set %_GetEmptyLines_output%[%%f]=%%g
	for /f "tokens=1,2* delims=:" %%f in ("%%a") do set %_GetEmptyLines_output_rows%[%%g].type=EmptyLine
	)
set /a "%_GetEmptyLines_output%.lbound=1" & set "_GetEmptyLines_output=" & set "_GetEmptyLines_output_rows="
GoTo :EOF

::Usage Call :GetEndOfFunction Filename OutputArray optional OutputRows
:GetEndOfFunction
set "_GetEndOfFunction_output=%~2"
if "[%~3]" EQU "[]" ( set "_GetEndOfFunction_output_rows=%_GetEndOfFunction_output%.rows" ) else ( set "_GetEndOfFunction_output_rows=%~3" )
for /f delims^=^ eol^= %%a in ('%SystemRoot%\System32\findstr /N /I /C:":EndOf_" "%~1" ^| findstr /N "^"') do ( 
	for /f "tokens=1,2,3* delims=:" %%f in ("%%a") do set /a "%_GetEndOfFunction_output%.ubound=%%f" & set %_GetEndOfFunction_output%[%%f]=%%g
	for /f "tokens=1,2,* delims=:" %%f in ("%%a") do set %_GetEndOfFunction_output%[%%f].text=:%%h
	for /f "tokens=1,2,* delims=:" %%f in ("%%a") do set %_GetEndOfFunction_output_rows%[%%g]=:%%h
	for /f "tokens=1,2,* delims=:" %%f in ("%%a") do set %_GetEndOfFunction_output_rows%[%%g].type=EndOf_Function
	for /f "tokens=1,2,3* delims=:" %%f in ("%%a") do for /f "tokens=*" %%z in ("%%h") do set %_GetEndOfFunction_output%[%%f].name=%%~z
	for /f "tokens=1,2,3* delims=:" %%f in ("%%a") do for /f "tokens=1,2*" %%z in ("%%h") do set %_GetEndOfFunction_output%.name[%%~z]=%%g
	for /f "tokens=2 delims=:" %%b in ("%%a") do for /f "tokens=1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24 delims=:" %%c in ("%%a") do for %%A in (%%c %%d %%e %%f %%g %%h %%i %%j %%k %%l %%m %%n %%o %%p %%q %%r %%s %%t %%u %%v %%w %%x %%y %%z) do (
											set _GetEndOfFunction_buffer=%%A
											setlocal enabledelayedexpansion
											if "[!_GetEndOfFunction_buffer:~,6!]" EQU "[EndOf_]" set _GetEndOfFunction_buffer2=!_GetEndOfFunction_buffer!
											for %%Z in (!_GetEndOfFunction_buffer2!) do endlocal & set %_GetEndOfFunction_output%.name[%%~Z]=%%b
											REM this next endlocal should be changed to only run inside of _function_localscope=true
											endlocal 
											)
	)
	set /a "%_GetEndOfFunction_output%.lbound=1" & set "_GetEndOfFunction_output=" & set "_GetEndOfFunction_output_rows="
GoTo :EOF

::Usage Call :FindFunctionLabel FunctionArray NameOfFunction optional ReturnValue
::Returns index number as errorlevel
:FindFunctionLabel
set "_FindFunctionLabel_prefix=_FFL"
set "_FFL_Input=%~1"
if defined %_FFL_Input%.lbound ( call set /a "_FFL_Input_lbound=%%%_FFL_Input%.lbound%%" ) else ( set /a "_FFL_Input_lbound=0" )
if defined %_FFL_Input%.lbound ( call set /a "_FFL_Input_ubound=%%%_FFL_Input%.ubound%%" ) else ( echo Function Array without ubound value, quitting & GoTo :EOF )
shift 
:FindFunctionLabel-args
set "_FFL_FunctionName=%~1"
set "_FFL_ReturnValue=%~2"
if not defined _FFL_FunctionName ( echo No function name specified, quitting & GoTo :EOF )
set "_FFL_result="
set /a "_FFL_Input_index=%_FFL_Input_lbound%"
:FindFunctionLabel-loop
call set "_FFL_current_text=%%%_FFL_Input%[%_FFL_Input_index%].name%%"
if "[%_FFL_current_text%]" EQU "[%_FFL_FunctionName%]" ( set /a "_FFL_result=%_FFL_Input_index%" & GoTo :FindFunctionLabel-end )
set /a "_FFL_Input_index+=1"
if %_FFL_Input_index% LEQ %_FFL_Input_ubound% GoTo :FindFunctionLabel-loop
:FindFunctionLabel-end
if defined _FFL_ReturnValue ( set "%_FFL_ReturnValue%=%_FFL_result%" )
if "[%~3]" NEQ "[]" if "[%~4]" NEQ "[]" ( shift & shift & GoTo :FindFunctionLabel-args )
Call :ClearVariablesByPrefix %_FindFunctionLabel_prefix% _FindFunctionLabel_prefix & exit /b %_FFL_result%

::Usage Call :FindPreviousEmptyRow FunctionArray FunctionNameOrIndex optional ReturnValue
:FindPreviousEmptyRow
set "_FindPreviousEmptyRow_prefix=_FPER"
set "_FPER_Input=%~1"
if defined %_FPER_Input%.lbound ( call set /a "_FPER_Input_lbound=%%%_FPER_Input%.lbound%%" ) else ( set /a "_FPER_Input_lbound=0" )
if defined %_FPER_Input%.ubound ( call set /a "_FPER_Input_ubound=%%%_FPER_Input%.ubound%%" ) else ( echo Function Array without ubound value, quitting & GoTo :EOF )
shift 
:FindPreviousEmptyRow-args
set "_FPER_FunctionName=%~1"
set "_FPER_ReturnValue=%~2"
if not defined _FPER_FunctionName ( echo No function name specified, quitting & GoTo :EOF )
set "_FPER_FunctionNameIndex="
if defined %_FPER_Input%[%_FPER_FunctionName%] ( set /a "_FPER_FunctionNameIndex=%_FPER_FunctionName%" ) else ( Call :FindFunctionLabel %_FPER_Input% "%_FPER_FunctionName%" _FPER_FunctionNameIndex )
set "_FPER_result="
set /a "_FPER_Input_index=%_FPER_FunctionNameIndex%-1"
:FindPreviousEmptyRow-loop
call set "_FPER_CurrentType=%%%_FPER_Input%[%_FPER_Input_index%].type%%"
if "[%_FPER_CurrentType%]" EQU "[Empty]" ( call set /a "_FPER_result=%%%_FPER_Input%[%_FPER_Input_index%]%%" & GoTo :FindPreviousEmptyRow-end )
set /a "_FPER_Input_index-=1"
if %_FPER_Input_index% GEQ %_FPER_Input_ubound% GoTo :FindPreviousEmptyRow-loop
:FindPreviousEmptyRow-end
if defined _FPER_ReturnValue ( set /a "%_FPER_ReturnValue%=%_FPER_result%" )
if "[%~3]" NEQ "[]" if "[%~4]" NEQ "[]" ( shift & shift & GoTo :FindPreviousEmptyRow-args )
Call :ClearVariablesByPrefix %_FindPreviousEmptyRow_prefix% _FindPreviousEmptyRow_prefix & exit /b %_FPER_result%

::Usage Call :FindFunctionExit FunctionArray NameOfFunction optional ReturnValue
::Returns index number as errorlevel
:FindFunctionExit
set "_FindFunctionExit_prefix=_FFE"
set "_FFE_Input=%~1"
if defined %_FFE_Input%.lbound ( call set /a "_FFE_Input_lbound=%%%_FFE_Input%.lbound%%" ) else ( set /a "_FFE_Input_lbound=0" )
if defined %_FFE_Input%.ubound ( call set /a "_FFE_Input_ubound=%%%_FFE_Input%.ubound%%" ) else ( echo Function Array without ubound value, quitting & GoTo :EOF )
shift 
:FindFunctionExit-args
set "_FFE_FunctionName=%~1"
set "_FFE_ReturnValue=%~2"
if not defined _FFE_FunctionName ( echo No function name specified, quitting & GoTo :EOF )
set "_FFE_FunctionNameIndex="
if defined %_FFE_Input%[%_FFE_FunctionName%] ( set /a "_FFE_FunctionNameIndex=%_FFE_FunctionName%" ) else ( Call :FindFunctionLabel %_FFE_Input% "%_FFE_FunctionName%" _FFE_FunctionNameIndex )
set "_FFE_result="
Call :FindNextExitRowIndex %_FFE_Input% %_FFE_FunctionNameIndex% _FFE_NextExit
Call :FindNextFunctionLabelIndex %_FFE_Input% %_FFE_NextExit% _FFE_NextLabel
Call :FindPreviousExitRowIndex %_FFE_Input% %_FFE_NextLabel% _FFE_ProbableExit
call set "_FFE_FunctionNameVerbatim=%%%_FFE_Input%[%_FFE_FunctionName%].name%%"
if defined %_FFE_Input%.endof.name[EndOf_%_FFE_FunctionNameVerbatim%] Call :FindFunctionEOF %_FFE_Input% %_FFE_FunctionNameVerbatim% _FFE_ProbableExit
set /a "_FFE_result=%_FFE_ProbableExit%"
if defined _FFE_ReturnValue ( set "%_FFE_ReturnValue%=%_FFE_result%" )
if "[%~3]" NEQ "[]" if "[%~4]" NEQ "[]" ( shift & shift & GoTo :FindFunctionExit-args )
Call :ClearVariablesByPrefix %_FindFunctionExit_prefix% _FindFunctionExit_prefix & exit /b %_FFE_result%

::Usage Call :FindNextEmptyRow FunctionArray FunctionNameOrIndex optional ReturnValue
:FindNextEmptyRow
set "_FindNextEmptyRow_prefix=_FNER"
set "_FNER_Input=%~1"
if defined %_FNER_Input%.lbound ( call set /a "_FNER_Input_lbound=%%%_FNER_Input%.lbound%%" ) else ( set /a "_FNER_Input_lbound=0" )
if defined %_FNER_Input%.ubound ( call set /a "_FNER_Input_ubound=%%%_FNER_Input%.ubound%%" ) else ( echo Function Array without ubound value, quitting & GoTo :EOF )
shift 
:FindNextEmptyRow-args
set "_FNER_FunctionName=%~1"
set "_FNER_ReturnValue=%~2"
if not defined _FNER_FunctionName ( echo No function name specified, quitting & GoTo :EOF )
set "_FNER_FunctionNameIndex="
if defined %_FNER_Input%[%_FNER_FunctionName%] ( set /a "_FNER_FunctionNameIndex=%_FNER_FunctionName%" ) else ( Call :FindFunctionLabel %_FNER_Input% "%_FNER_FunctionName%" _FNER_FunctionNameIndex )
set "_FNER_result="
set /a "_FNER_Input_index=%_FNER_FunctionNameIndex%+1"
:FindNextEmptyRow-loop
call set "_FNER_CurrentType=%%%_FNER_Input%[%_FNER_Input_index%].type%%"
if "[%_FNER_CurrentType%]" EQU "[Empty]" ( call set /a "_FNER_result=%%%_FNER_Input%[%_FNER_Input_index%]%%" & GoTo :FindNextEmptyRow-end )
set /a "_FNER_Input_index+=1"
if %_FNER_Input_index% LEQ %_FNER_Input_ubound% GoTo :FindNextEmptyRow-loop
:FindNextEmptyRow-end
if defined _FNER_ReturnValue ( set /a "%_FNER_ReturnValue%=%_FNER_result%" )
if "[%~3]" NEQ "[]" if "[%~4]" NEQ "[]" ( shift & shift & GoTo :FindNextEmptyRow-args )
Call :ClearVariablesByPrefix %_FindNextEmptyRow_prefix% _FindNextEmptyRow_prefix & exit /b %_FNER_result%

::Usage Call :GetEndOfFunctionRow FunctionArray FunctionNameOrIndex optional ReturnValue
:GetEndOfFunctionRow
set "_GetEndOfFunctionRow_prefix=_GEoFR"
set "_GEoFR_Input=%~1"
if defined %_GEoFR_Input%.lbound ( call set /a "_GEoFR_Input_lbound=%%%_GEoFR_Input%.lbound%%" ) else ( set /a "_GEoFR_Input_lbound=0" )
if defined %_GEoFR_Input%.ubound ( call set /a "_GEoFR_Input_ubound=%%%_GEoFR_Input%.ubound%%" ) else ( echo Function Array without ubound value, quitting & GoTo :EOF )
shift 
:GetEndOfFunctionRow-args
set "_GEoFR_FunctionName=%~1"
set "_GEoFR_ReturnValue=%~2"
if not defined _GEoFR_FunctionName ( echo No function name specified, quitting & GoTo :EOF )
set "_GEoFR_FunctionNameIndex="
set /a "_GEoFR_result=0"
if defined %_GEoFR_Input%[%_GEoFR_FunctionName%] ( call set /a "_GEoFR_result=%%%_GEoFR_Input%[%_GEoFR_FunctionName%]%%" )
if defined %_GEoFR_Input%.name[EndOf_%_GEoFR_FunctionName%] ( call set /a "_GEoFR_result=%%%_GEoFR_Input%.name[EndOf_%_GEoFR_FunctionName%]%%" )
if defined _GEoFR_ReturnValue ( set /a "%_GEoFR_ReturnValue%=%_GEoFR_result%" & set "%_GEoFR_ReturnValue%.name=%_GEoFR_result_name%" )
if "[%~3]" NEQ "[]" if "[%~4]" NEQ "[]" ( shift & shift & GoTo :GetEndOfFunctionRow-args )
Call :ClearVariablesByPrefix %_GetEndOfFunctionRow_prefix% _GetEndOfFunctionRow_prefix & exit /b %_GEoFR_result%

::Usage Call :FindNextExitRowIndex FunctionArray FunctionNameOrIndex optional ReturnValue
:FindNextExitRowIndex
set "_FindNextExitRowIndex_prefix=_FNXRI"
set "_FNXRI_Input=%~1"
if defined %_FNXRI_Input%.lbound ( call set /a "_FNXRI_Input_lbound=%%%_FNXRI_Input%.lbound%%" ) else ( set /a "_FNXRI_Input_lbound=0" )
if defined %_FNXRI_Input%.ubound ( call set /a "_FNXRI_Input_ubound=%%%_FNXRI_Input%.ubound%%" ) else ( echo Function Array without ubound value, quitting & GoTo :EOF )
shift 
:FindNextExitRowIndex-args
set "_FNXRI_FunctionName=%~1"
set "_FNXRI_ReturnValue=%~2"
if not defined _FNXRI_FunctionName ( echo No function name specified, quitting & GoTo :EOF )
set "_FNXRI_FunctionNameIndex="
if defined %_FNXRI_Input%[%_FNXRI_FunctionName%] ( set /a "_FNXRI_FunctionNameIndex=%_FNXRI_FunctionName%" ) else ( Call :FindFunctionLabel %_FNXRI_Input% "%_FNXRI_FunctionName%" _FNXRI_FunctionNameIndex )
set "_FNXRI_result="
set /a "_FNXRI_Input_index=%_FNXRI_FunctionNameIndex%+1"
:FindNextExitRowIndex-loop
call set "_FNXRI_CurrentType=%%%_FNXRI_Input%[%_FNXRI_Input_index%].type%%"
if "[%_FNXRI_CurrentType%]" EQU "[Exits]" ( set /a "_FNXRI_result=%_FNXRI_Input_index%" & GoTo :FindNextExitRowIndex-end )
set /a "_FNXRI_Input_index+=1"
if %_FNXRI_Input_index% LEQ %_FNXRI_Input_ubound% GoTo :FindNextExitRowIndex-loop
:FindNextExitRowIndex-end
if defined _FNXRI_ReturnValue ( set /a "%_FNXRI_ReturnValue%=%_FNXRI_result%" )
if "[%~3]" NEQ "[]" if "[%~4]" NEQ "[]" ( shift & shift & GoTo :FindNextExitRowIndex-args )
Call :ClearVariablesByPrefix %_FindNextExitRowIndex_prefix% _FindNextExitRowIndex_prefix & exit /b %_FNXRI_result%

::Usage Call :FindNextFunctionLabelIndex FunctionArray FunctionNameOrIndex optional ReturnValue
:FindNextFunctionLabelIndex
set "_FindNextFunctionLabelIndex_prefix=_FNFLI"
set "_FNFLI_Input=%~1"
if defined %_FNFLI_Input%.lbound ( call set /a "_FNFLI_Input_lbound=%%%_FNFLI_Input%.lbound%%" ) else ( set /a "_FNFLI_Input_lbound=0" )
if defined %_FNFLI_Input%.ubound ( call set /a "_FNFLI_Input_ubound=%%%_FNFLI_Input%.ubound%%" ) else ( echo Function Array without ubound value, quitting & GoTo :EOF )
shift 
:FindNextFunctionLabelIndex-args
set "_FNFLI_FunctionName=%~1"
set "_FNFLI_ReturnValue=%~2"
if not defined _FNFLI_FunctionName ( echo No function name specified, quitting & GoTo :EOF )
set "_FNFLI_FunctionNameIndex="
if defined %_FNFLI_Input%[%_FNFLI_FunctionName%] ( set /a "_FNFLI_FunctionNameIndex=%_FNFLI_FunctionName%" ) else ( Call :FindFunctionLabel %_FNFLI_Input% "%_FNFLI_FunctionName%" _FNFLI_FunctionNameIndex )
set "_FNFLI_result="
set /a "_FNFLI_Input_index=%_FNFLI_FunctionNameIndex%+1"
:FindNextFunctionLabelIndex-loop
call set "_FNFLI_CurrentType=%%%_FNFLI_Input%[%_FNFLI_Input_index%].type%%"
if "[%_FNFLI_CurrentType%]" EQU "[Labels]" ( set /a "_FNFLI_result=%_FNFLI_Input_index%" & call set "_FNFLI_result_name=%%%_FNFLI_Input%[%_FNFLI_Input_index%].name%%" & GoTo :FindNextFunctionLabelIndex-end )
set /a "_FNFLI_Input_index+=1"
if %_FNFLI_Input_index% LEQ %_FNFLI_Input_ubound% GoTo :FindNextFunctionLabelIndex-loop
:FindNextFunctionLabelIndex-end
if defined _FNFLI_ReturnValue ( set /a "%_FNFLI_ReturnValue%=%_FNFLI_result%" & set "%_FNFLI_ReturnValue%.name=%_FNFLI_result_name%" )
if "[%~3]" NEQ "[]" if "[%~4]" NEQ "[]" ( shift & shift & GoTo :FindNextFunctionLabelIndex-args )
Call :ClearVariablesByPrefix %_FindNextFunctionLabelIndex_prefix% _FindNextFunctionLabelIndex_prefix & exit /b %_FNFLI_result%

::Usage Call :FindPreviousExitRowIndex FunctionArray FunctionNameOrIndex optional ReturnValue
:FindPreviousExitRowIndex
set "_FindPreviousExitRowIndex_prefix=_FPXRI"
set "_FPXRI_Input=%~1"
if defined %_FPXRI_Input%.lbound ( call set /a "_FPXRI_Input_lbound=%%%_FPXRI_Input%.lbound%%" ) else ( set /a "_FPXRI_Input_lbound=0" )
if defined %_FPXRI_Input%.ubound ( call set /a "_FPXRI_Input_ubound=%%%_FPXRI_Input%.ubound%%" ) else ( echo Function Array without ubound value, quitting & GoTo :EOF )
shift 
:FindPreviousExitRowIndex-args
set "_FPXRI_FunctionName=%~1"
set "_FPXRI_ReturnValue=%~2"
if not defined _FPXRI_FunctionName ( echo No function name specified, quitting & GoTo :EOF )
set "_FPXRI_FunctionNameIndex="
if defined %_FPXRI_Input%[%_FPXRI_FunctionName%] ( set /a "_FPXRI_FunctionNameIndex=%_FPXRI_FunctionName%" ) else ( Call :FindFunctionLabel %_FPXRI_Input% "%_FPXRI_FunctionName%" _FPXRI_FunctionNameIndex )
set "_FPXRI_result="
set /a "_FPXRI_Input_index=%_FPXRI_FunctionNameIndex%-1"
:FindPreviousExitRowIndex-loop
call set "_FPXRI_CurrentType=%%%_FPXRI_Input%[%_FPXRI_Input_index%].type%%"
if "[%_FPXRI_CurrentType%]" EQU "[Exits]" ( set /a "_FPXRI_result=%_FPXRI_Input_index%" & GoTo :FindPreviousExitRowIndex-end )
set /a "_FPXRI_Input_index-=1"
if %_FPXRI_Input_index% GEQ %_FPXRI_Input_lbound% GoTo :FindPreviousExitRowIndex-loop
:FindPreviousExitRowIndex-end
if defined _FPXRI_ReturnValue ( set /a "%_FPXRI_ReturnValue%=%_FPXRI_result%" )
if "[%~3]" NEQ "[]" if "[%~4]" NEQ "[]" ( shift & shift & GoTo :FindPreviousExitRowIndex-args )
Call :ClearVariablesByPrefix %_FindPreviousExitRowIndex_prefix% _FindPreviousExitRowIndex_prefix & exit /b %_FPXRI_result%

::Usage Call :FindFunctionEOF FunctionArray NameOfFunction optional ReturnValue
::Returns index number as errorlevel
:FindFunctionEOF
set "_FindFunctionEOF_prefix=_FFEOF"
set "_FFEOF_Input=%~1"
if defined %_FFEOF_Input%.lbound ( call set /a "_FFEOF_Input_lbound=%%%_FFEOF_Input%.lbound%%" ) else ( set /a "_FFEOF_Input_lbound=0" )
if defined %_FFEOF_Input%.lbound ( call set /a "_FFEOF_Input_ubound=%%%_FFEOF_Input%.ubound%%" ) else ( echo Function Array without ubound value, quitting & GoTo :EOF )
shift 
:FindFunctionEOF-args
set "_FFEOF_FunctionName=%~1"
set "_FFEOF_ReturnValue=%~2"
if not defined _FFEOF_FunctionName ( echo No function name specified, quitting & GoTo :EOF )
set "_FFEOF_result="
set /a "_FFEOF_Input_index=%_FFEOF_Input_lbound%"
:FindFunctionEOF-loop
call set "_FFEOF_current_type=%%%_FFEOF_Input%[%_FFEOF_Input_index%].type%%"
if "[%_FFEOF_current_type%]" NEQ "[EOF]" GoTo :FindFunctionEOF-skip
call set "_FFEOF_current_text=%%%_FFEOF_Input%[%_FFEOF_Input_index%].name%%"
if "[%_FFEOF_current_text%]" NEQ "[%_FFEOF_buffer%]" ( set /a "_FFEOF_result=%_FFEOF_Input_index%" & GoTo :FindFunctionEOF-end )
:FindFunctionEOF-skip
set /a "_FFEOF_Input_index+=1"
if %_FFEOF_Input_index% LEQ %_FFEOF_Input_ubound% GoTo :FindFunctionEOF-loop
:FindFunctionEOF-end
if defined _FFEOF_result if defined _FFEOF_ReturnValue ( set "%_FFEOF_ReturnValue%=%_FFEOF_result%" )
if "[%~3]" NEQ "[]" if "[%~4]" NEQ "[]" ( shift & shift & GoTo :FindFunctionEOF-args )
Call :ClearVariablesByPrefix %_FindFunctionEOF_prefix% _FindFunctionEOF_prefix & exit /b %_FFEOF_result%


















REM ::Usage Call :GetLabels BatchFile LabelObjectArray optional RowsArray
REM :GetLabelsOnly
REM set "_GetLabels_output=%~2"
REM if "[%~3]" EQU "[]" ( set "_GetLabels_output_rows=%_GetLabels_output%.rows" ) else ( set "_GetLabels_output_rows=%~3" )
REM for /f delims^=^ eol^= %%a in ('%SystemRoot%\System32\findstr /N "^:[^:]" "%~1" ^| findstr /N "^"') do (
	REM for /f "tokens=1,2,3* delims=:" %%f in ("%%a") do set /a "%_GetLabels_output%.ubound=%%f" & REM set %_GetLabels_output%[%%f]=%%g
	REM REM for /f "tokens=1,2,3* delims=:" %%f in ("%%a") do set %_GetLabels_output_rows%[%%g].type=label
	REM for /f "tokens=1,2,3* delims=:" %%f in ("%%a") do for /f "tokens=1,2*" %%z in ("%%h") do set %_GetLabels_output%[%%f].name=%%~z
	REM REM for /f "tokens=1,2,3* delims=:" %%f in ("%%a") do for /f "tokens=1,2*" %%z in ("%%h") do set %_GetLabels_output%.name[%%~z]=%%g
	REM REM for /f "tokens=1,2,3* delims=:" %%f in ("%%a") do for /f "tokens=1,2*" %%z in ("%%h") do set %_GetLabels_output_rows%[%%g]=%%~z
	REM )
REM set /a "%_GetLabels_output%.lbound=1" & set "_GetLabels_output=" & set "_GetLabels_output_rows="
REM GoTo :EOF



::Usage Call :RemoveNonFunctionLabels ListOfLabels .rowsArray
:RemoveNonFunctionLabels
set "_RemoveNonFunctionLabels_prefix=_RNFL"
set "_RNFL_Labels=%~1"
call set "_RNFL_Labels_lbound=%%%~1.lbound%%"
call set "_RNFL_Labels_ubound=%%%~1.ubound%%"
if "[%_RNFL_Labels_lbound%]" EQU "[]" set /a "_RNFL_Labels_lbound=0"
set "_RNFL_Rows=%~2"
set /a "_RNFL_Index=%_RNFL_Labels_lbound%"
:RemoveNonFunctionLabels-loop
Call set "_RNFL_CurrentLabel=%%%_RNFL_Labels%[%_RNFL_Index%].name%%" & call set "_RNFL_CurrentRow=%%%_RNFL_Labels%[%_RNFL_Index%]%%" 
Call :IsFunctionLabelExcluded %_RNFL_CurrentLabel% && ( set "%_RNFL_Rows%[%_RNFL_CurrentRow%]=" & set "%_RNFL_Rows%[%_RNFL_CurrentRow%].type=" &  set "%_RNFL_Labels%[%_RNFL_Index%]=" & set "%_RNFL_Labels%[%_RNFL_Index%].name=" & set "%_RNFL_Labels%.name[%_RNFL_CurrentLabel%]=" )
set /a "_RNFL_Index+=1"
if %_RNFL_Index% LEQ %_RNFL_Labels_ubound% GoTo :RemoveNonFunctionLabels-loop
Call :ClearVariablesByPrefix %_RemoveNonFunctionLabels_prefix% _RemoveNonFunctionLabels
GoTo :EOF

::Usage Call :IsFunctionLabelExcluded FunctionLabel ExclusionList
:IsFunctionLabelExcluded
set "_IFLE_input=%~1"
set "_IFLE_input=%_IFLE_input:-= %"
set "_IFLE_input=%_IFLE_input::= %"
set "_IFLE_ExclusionList=%~2"
if "[%_IFLE_ExclusionList%]" EQU "[]" set "_IFLE_ExclusionList=main setup end loop loop2 loop3 loop4 skip skip1 skip2 skip2 skip3 skip4 test test1 test2 test3 cleanup argument params args next prev iteration pre post 0 1 2 3 4 5 6 7 8 9 subloop matchfound nomatch found index list arguments preamble test4 test5 test6 start reset"
for %%a in (%_IFLE_input%) do set _IFLE_last_token=%%a
for %%a in (%_IFLE_ExclusionList%) do if %%a EQU %_IFLE_last_token% exit /b 0
if "[%_IFLE_input:~,6%]" EQU "[EndOf_]" exit /b 0
exit /b 1

REM functional
REM add echo array "verticalmode" (no LF between array elements)
::Usage Call :EchoArray InputArray optional LINENUMBERS optional SHOWVARNAME optional .Suffix optional IndexRange
:EchoArray
set "_EchoArray_input=%~1"
call set /a "_EchoArray_lbound=%%%~1.lbound" 2>nul
if "[%_EchoArray_lbound%]" EQU "[]" set /a "_EchoArray_lbound=0"
call set /a "_EchoArray_ubound=%%%~1.ubound"
set /a "_EchoArray_index=%_EchoArray_lbound%"
shift
:EchoArray-arguments
set "_EchoArray_buffer=%~1"
if not defined _EchoArray_buffer GoTo :EchoArray-arguments-end
if "[%_EchoArray_buffer:~,1%]" EQU "[.]" ( set "_EchoArray_suffix=%_EchoArray_buffer%" & shift & GoTo :EchoArray-arguments )
if "[%_EchoArray_buffer%]" EQU "[LINENUMBERS]" ( set "_EchoArray_showlinenumbers=true" & shift & GoTo :EchoArray-arguments )
if "[%_EchoArray_buffer%]" EQU "[SHOWVARNAME]" ( set "_EchoArray_showvariablename=true" & shift & GoTo :EchoArray-arguments )
if "[%_EchoArray_buffer%]" EQU "[VERTICALMODE]" ( set "_EchoArray_verticalmode=true" & shift & GoTo :EchoArray-arguments )
REM if "[%~1]" NEQ "[]" if not defined _EchoArray_IndexList.lbound set /a "_EchoArray_IndexList.lbound=1"
if "[%~1]" NEQ "[]" ( Call :GetIndexArray _EchoArray_IndexList "%~1" & shift & GoTo :EchoArray-arguments )
:EchoArray-arguments-end
if defined _EchoArray_IndexList.ubound set /a "_EchoArray_ubound=%_EchoArray_IndexList.ubound%"
setlocal enabledelayedexpansion
:EchoArray-loop
if not defined _EchoArray_IndexList.ubound ( set "_EchoArray_index_actual=%_EchoArray_index%" ) else ( set "_EchoArray_index_actual=!_EchoArray_IndexList[%_EchoArray_index%]!" )
if defined _EchoArray_showlinenumbers set _EchoArray_prefix=%_EchoArray_index%:
if defined _EchoArray_showvariablename set _EchoArray_prefix=%_EchoArray_input%[%_EchoArray_index_actual%]:
if defined _EchoArray_showvariablename if defined _EchoArray_showlinenumbers set _EchoArray_prefix=%_EchoArray_index%:%_EchoArray_input%[%_EchoArray_index_actual%]:
if not defined _EchoArray_verticalmode GoTo :EchoArray-normalmode-loop-next
<nul set /p =%_EchoArray_prefix%!%_EchoArray_input%[%_EchoArray_index_actual%]%_EchoArray_suffix%! 
GoTo :EchoArray-loop-next
:EchoArray-normalmode-loop-next
REM echo(%_EchoArray_prefix%%_EchoArray_input%[%_EchoArray_index_actual%]%_EchoArray_suffix%
echo(%_EchoArray_prefix%!%_EchoArray_input%[%_EchoArray_index_actual%]%_EchoArray_suffix%!
:EchoArray-loop-next
set /a "_EchoArray_index+=1"
if %_EchoArray_index% LEQ %_EchoArray_ubound% GoTo :EchoArray-loop
:EchoArray-loop-end
endlocal
Call :ClearVariablesByPrefix _EchoArray
GoTo :EOF

REM ToDo add range limits, at least lbound, if ubound, then ubound adjuster at the end will need work
REM maybe arr[] arr[].suffix or arr[].* ?
REM maybe add ability to output to a new compacted array, instead of moving elements of current array ?
REM tentative ::Usage Call :CompactArray InputArray optional OutputArray
REM tentative ::Usage Call :CompactArray InputArray optional OutputArray optional lbound=X optional ubound=Y
REM tentative ::Usage Call :CompactArray InputArray[].mysuffix optional OutputArray optional lbound=X optional ubound=Y
::Usage Call :CompactArray InputArray
:CompactArray
set "_CompactArray_prefix=_CA
set "_CA_Input=%~1"
call set "_CA_Input_lbound=%%%_CA_Input%.lbound%%"
call set "_CA_Input_ubound=%%%_CA_Input%.ubound%%"
if "[%_CA_Input_lbound%]" EQU "[]" set "_CA_Input_lbound=0"
set /a "_CA_Index=%_CA_Input_lbound%"
set /a "_CA_Previous=%_CA_Index%-1"
if defined %_CA_Input%[%_CA_Index%] ( set /a "_CA_LastEmptyElement=%_CA_Index%+1" ) else ( set /a "_CA_LastEmptyElement=%_CA_Index%" )
:CompactArray-loop
REM if defined %_CA_Input%[%_CA_Index%] if %_CA_LastEmptyElement% LEQ %_CA_Previous% ( echo :MoveObject %_CA_Input%[%_CA_Index%] %_CA_Input%[%_CA_LastEmptyElement%] "_CA_LastEmptyElement+=1 %_CA_LastEmptyElement%" )
if defined %_CA_Input%[%_CA_Index%] if %_CA_LastEmptyElement% LEQ %_CA_Previous% ( Call :MoveObject %_CA_Input%[%_CA_Index%] %_CA_Input%[%_CA_LastEmptyElement%] & set /a "_CA_LastEmptyElement+=1" )
if defined %_CA_Input%[%_CA_Index%] set /a "_CA_LastEmptyElement=%_CA_Index%+1"
set /a "_CA_Previous+=1" & set /a "_CA_Index+=1"
if %_CA_Index% LEQ %_CA_Input_ubound% GoTo :CompactArray-loop
set /a "%_CA_Input%.ubound=%_CA_LastEmptyElement%-1"
Call :ClearVariablesByPrefix %_CompactArray_prefix% _CompactArray
GoTo :EOF

:: TODO PadLeft, PadAtPosition
::Usage Call :PadString Count InputString optional OutputString
:PadString
set "_PadString_prefix=_PS"
set "_PS_Count=%~1"
set "_PS_Input=%~2"
set "_PS_Output=%~3"
if not defined _PS_Output set "_PS_Output=_PS_Input"
set "_PS_buffer=%_PS_Input%"
:PadString-loop
call set "_PS_len=%%_PS_buffer:~%_PS_Count%,1%%"
if not defined _PS_len ( set "_PS_buffer=%_PS_buffer% " & GoTo :PadString-loop )
set "%_PS_Output%=%_PS_buffer%"
Call :ClearVariablesByPrefix %_PadString_prefix% _PadString_prefix 
GoTo :EOF

:: Usage Call :ClearVariablesByPrefix myPrefix
:ClearVariablesByPrefix
if "[%~1]" NEQ "[]" for /f "tokens=1 delims==" %%a in ('set "%~1" 2^>nul') do set %%a=
if "[%~2]" NEQ "[]" shift & GoTo :ClearVariablesByPrefix
GoTo :EOF